<template>
  <div class="bgGrey font-16 q-pt-md" align="center">
    <div style="width: 90%; margin: auto">
      <div class="q-py-xl row items-center">
        <div class="font-12" align="left">
          <div class="font-30"><b>Dimension</b></div>
          <div class="">Select a dimension to see detail</div>
        </div>
        <div class="" style="width: 450px">
          <q-select
            class="inputSelectClass"
            dark
            dense
            v-model="selected"
            :style="{ background: colorSelected }"
            :options="dimensionOptions"
            @input="changeDimension()"
          />
        </div>
      </div>
      <div class="q-pt-sm">
        <q-card flat class="cardStyle">
          <q-tabs
            v-model="tab"
            class="text-grey"
            active-color="secondary"
            indicator-color="secondary"
            align="justify"
            narrow-indicator
            no-caps
            @click="changeTab()"
          >
            <q-tab name="economy" label="By economy" />
            <q-tab name="index" label="By indicator (and economy)" />
            <q-tab name="data" label="Indicator data availability" />
            <q-tab name="weight" label="Indicator weights in dimension" />
            <div
              class="font-12 cursor-pointer q-px-md"
              align="center"
              @click="goToURL()"
            >
              <u>Click here to see this group’s availability matrix</u>
            </div>
          </q-tabs>

          <q-separator />

          <q-tab-panels v-model="tab" animated style="background: #ededed">
            <q-tab-panel name="economy">
              <div v-if="showAvail">
                <div class="q-px-xl" align="left">
                  <div class="font-24 q-py-md">
                    Which partner economies are performing best in
                    {{ selected.toLowerCase() }} integration?
                  </div>
                  <div>
                    From top to bottom in descending order of % score
                    progression between periods.
                  </div>
                </div>
                <div class="economyOverflow">
                  <div id="z"></div>
                </div>
              </div>
              <div v-else>
                <div class="noDataAvail">No data available</div>
              </div>
            </q-tab-panel>

            <q-tab-panel name="index">
              <div v-if="showAvail">
                <div class="q-px-xl" align="left">
                  <div class="font-24">
                    Which indicators are driving
                    {{
                      input.reporting.length > 1
                        ? "the reporting economies"
                        : input.reporting[0].label
                    }}
                    {{ selected.toLowerCase() }} integration score with
                    {{
                      input.partner.length > 1
                        ? "this group of partner economies"
                        : input.partner[0].label
                    }}?
                  </div>
                  <p class="font-16">
                    From {{ firstHalfPeriod }} to {{ secondHalfPeriod }}, your
                    reporter group's integration with your partner group in
                    {{ selected }} dimension
                    {{
                      indexChart.series[1].data[0] -
                        indexChart.series[0].data[0] >
                      0
                        ? "increased"
                        : "decreased"
                    }}
                    by
                    {{
                      Math.abs(
                        indexChart.series[1].data[0] -
                          indexChart.series[0].data[0]
                      ).toFixed(2)
                    }}
                    from
                    {{ Number(indexChart.series[0].data[0]).toFixed(2) }} to
                    {{ Number(indexChart.series[1].data[0]).toFixed(2) }}.
                    {{ indexChart.catName[0] }} (
                    {{
                      indexChart.series[1].data[0] -
                        indexChart.series[0].data[0] >
                      0
                        ? "+"
                        : "-"
                    }}{{
                      Math.abs(
                        indexChart.series[1].data[0] -
                          indexChart.series[0].data[0]
                      ).toFixed(2)
                    }}
                    ) progressed the most.
                    {{
                      indexChart.catName[indexChart.series[0].data.length - 1]
                    }}
                    ({{
                      indexChart.catName[indexChart.series[1].data.length - 1] -
                        indexChart.catName[
                          indexChart.series[0].data.length - 1
                        ] >
                      0
                        ? "+"
                        : "-"
                    }}{{
                      Math.abs(
                        indexChart.series[1].data[
                          indexChart.series[1].data.length - 1
                        ] -
                          indexChart.series[0].data[
                            indexChart.series[0].data.length - 1
                          ]
                      ).toFixed(2)
                    }}) progressed the least.
                  </p>
                  <span class="font-14">
                    Click on any indicator to breakdown performance by
                    individual economies.
                  </span>
                </div>
                <div class="economyOverflow2">
                  <div id="chartIndex"></div>
                  <div v-if="indexNoDataText != ''" class="q-py-md">
                    {{ indexNoDataText }}
                  </div>
                  <table-tab :dimension="dimensionIndex" :type="input.type" />
                </div>
              </div>
              <div v-else>
                <div class="noDataAvail">No data available</div>
              </div>
            </q-tab-panel>

            <q-tab-panel name="data">
              <div v-if="showAvail">
                <div class="q-px-xl" align="left">
                  <div class="font-24">
                    How much data is available for each indicator in
                    {{ selected.toLowerCase() }}?
                    <q-icon name="fas fa-question-circle" size="24px">
                      <q-tooltip>
                        Data availability for each indicator is calculated<br />
                        as the ratio between the number of pairs with<br />
                        available data and all the possible relevant pair<br />
                        combinations.<br /><br />

                        E.g., take any indicator A, and a group where X<br />
                        is the reporting economy and Y and Z are the<br />
                        partner economies. For indicator A, there are 2<br />
                        possible unique pairs: (X-Y), (X-Z). If data is<br />
                        available for 1 of these pairs, data availability<br />
                        for indicator A will be set at 50% (1/2)
                      </q-tooltip>
                    </q-icon>
                  </div>
                  <p class="font-16">
                    {{ dataChart.catName[0] }} has the most data available ({{
                      Number(dataChart.series[0].data[0]).toFixed(2)
                    }}%), while
                    {{
                      dataChart.catNameLower[
                        dataChart.series[0].data.length - 1
                      ]
                    }}
                    has the least ({{
                      Number(
                        dataChart.series[0].data[
                          dataChart.series[0].data.length - 1
                        ]
                      ).toFixed(2)
                    }}%). <br />
                  </p>
                </div>
                <div id="chartData"></div>
              </div>
              <div v-else>
                <div class="noDataAvail">No data available</div>
              </div>
            </q-tab-panel>

            <q-tab-panel name="weight">
              <div v-if="showAvail">
                <div class="q-px-xl" align="left">
                  <div class="font-24">
                    How much is each indicator contributing to
                    {{ yourGroupName }}'s {{ selected.toLowerCase() }} score?
                    <q-icon name="fas fa-question-circle" size="24px">
                      <q-tooltip>
                        Within a dimension and a particular pair, all<br />
                        available indicators are weighted equally.<br />
                        As such, indicator weights largely reflect data<br />
                        availability, albeit not perfectly. To learn more<br />
                        about indicator weights please visit our<br />
                        Technical note (upper-right corner).
                      </q-tooltip>
                    </q-icon>
                  </div>
                  <p class="font-16">
                    {{ weightChart.catName[0] }} ({{
                      Number(weightChart.series[0].data[0]).toFixed(2)
                    }}%) was the most prominent indicator in the
                    {{ selected.toLowerCase() }}
                    dimension, while
                    {{
                      weightChart.catNameLower[
                        weightChart.series[0].data.length - 1
                      ]
                    }}
                    ({{
                      Number(
                        weightChart.series[0].data[
                          weightChart.series[0].data.length - 1
                        ]
                      ).toFixed(2)
                    }}%) were the least.
                  </p>
                </div>
                <div id="chartWeight"></div>
              </div>
              <div v-else>
                <div class="noDataAvail">No data available</div>
              </div>
            </q-tab-panel>
          </q-tab-panels>
        </q-card>
      </div>
    </div>

    <!-- chart indicator  -->
    <div v-show="showIndicatorChart" class="fullscreen bgDrop">
      <div class="fixed-center cardIndicator q-pa-md">
        <div class="row items-center q-pb-none">
          <div
            class="inputSelectClass text-h6"
            :style="{ background: colorSelected }"
          >
            {{ selected }}
          </div>
          <q-space />
          <q-btn
            icon="close"
            size="lg"
            flat
            round
            dense
            @click="showIndicatorChart = false"
          />
        </div>
        <div class="q-py-md" align="left">
          <div class="font-24">{{ indicatorName }}</div>
          <div class="font-14">
            This graph is sorted by the different value between
            {{ firstHalfPeriod }} and {{ secondHalfPeriod }}.
          </div>
        </div>

        <div class="chartincard"><div id="chartIndicator"></div></div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import tableTab from "../main/ri_tableintab.vue";
export default {
  props: ["data", "input", "report"],
  components: {
    tableTab,
  },
  data() {
    return {
      showAvail: true,
      selected: "",
      tab: "economy",
      colorSelected: "",
      yourGroupName: "Your group",
      dimensionOptions: [],
      allDimensionData: [],
      firstHalfPeriod: "",
      secondHalfPeriod: "",
      //
      dimensionIndex: 1,
      countAllPair: 0,
      weightDataTemp: [],
      showIndicatorChart: false,
      indicatorName: "",
      indicatorIndex: 0,
      indicatorStr: [],
      indicatorChart: {
        catName: [],
        series: [
          {
            name: "",
            color: "#2381B8",
            data: [],
          },
          {
            name: "",
            color: "#13405A",
            data: [],
          },
        ],
      },
      economyChart: {
        catName: [],
        series: [
          {
            name: "",
            color: "#2381B8",
            data: [],
          },
          {
            name: "",
            color: "#13405A",
            data: [],
          },
        ],
      },
      indexNoDataText: "",
      indexChart: {
        //change catname when change dimension
        catName: [],
        series: [
          {
            name: "",
            color: "#2381B8",
            data: [],
          },
          {
            name: "",
            color: "#13405A",
            data: [],
          },
        ],
      },
      dataChart: {
        catName: [],
        catNameLower: [],
        series: [
          {
            name: "data available",
            color: "#2381B8",
            data: [],
          },
        ],
      },
      weightChart: {
        equalWeight: 1,
        catName: [],
        catNameLower: [],
        series: [
          {
            name: "weight",
            color: "#2381B8",
            data: [],
          },
        ],
      },
    };
  },
  methods: {
    async loadData() {
      if (this.input.year.min == this.input.year.max - 1) {
        this.firstHalfPeriod = this.input.year.min;
        this.secondHalfPeriod = this.input.year.max;
      } else {
        let diffYear = Math.floor(
          (this.input.year.max - this.input.year.min) / 2
        );
        this.firstHalfPeriod =
          this.input.year.min + "-" + (this.input.year.min + diffYear);
        this.secondHalfPeriod =
          this.input.year.max - diffYear + "-" + this.input.year.max;
      }
      this.allDimensionData = [];
      let data = {
        type: this.input.type,
      };
      let url = this.ri_api + "main/dimension_icon.php";
      let res = await axios.post(url, JSON.stringify(data));
      this.allDimensionData = res.data;
      this.allDimensionData.forEach((x) => {
        this.dimensionOptions.push(x.name);
      });
      this.countAllPair = 0;
      this.report.forEach((report) => {
        this.data.forEach((partner) => {
          if (report.iso != partner.iso) {
            this.countAllPair++;
          }
        });
      });

      this.selected = this.dimensionOptions[0];
      this.changeDimension();
    },
    async changeDimension() {
      // that mean change all chart
      for (let i = 0; i < this.allDimensionData.length; i++) {
        if (this.selected == this.allDimensionData[i].name) {
          this.colorSelected = this.allDimensionData[i].color;
          this.dimensionIndex = i + 1;
        }
      }
      this.loadAllChart();
    },
    async loadAllChart() {
      ////////
      this.loadingShow();
      await this.setIndexChart();
      await this.setDataChart();
      await this.setWeightChart();
      await this.setEconomyChart();
      this.loadingHide();
      /////

      this.changeTab();
    },
    changeTab() {
      if (this.tab == "index") {
        this.loadIndexChart();
      } else if (this.tab == "data") {
        this.loadDataChart();
      } else if (this.tab == "weight") {
        this.loadWeightChart();
      } else {
        this.loadEconomyChart();
      }
    },
    goToURL() {
      // this.getURL();
      let dataGet = this.$q.localStorage.getItem("dataAvail");
      this.id = dataGet.key;
      window.open("#/ridataavailability/" + this.id).focus;
      // this.$router.push("/ridataavailability/" + this.id);
    },
    /// chart
    async setIndexChart() {
      this.indicatorStr =
        this.allDimensionData[this.dimensionIndex - 1].indicator;
      let dataTemp = {
        input: this.input,
        partnerMap: this.data.map((x) => x.iso),
        reportMap: this.report.map((x) => x.iso),
        index: this.dimensionIndex,
        indicator: this.indicatorStr,
      };
      let url = this.ri_api + "economy/index_dimensiontab.php";
      let res = await axios.post(url, JSON.stringify(dataTemp));
      let result = res.data;
      let resultNoData = result
        .filter((x) => x.data[0] == 0 && x.data[0] == 0)
        .map((x) => x.catName);
      this.indexNoDataText = "";
      if (resultNoData.length > 0) {
        this.indexNoDataText = "No available for ";
        for (let iLoop = 0; iLoop < resultNoData.length - 1; iLoop++) {
          this.indexNoDataText += resultNoData[iLoop];
        }
        if (resultNoData.length == 1) {
          this.indexNoDataText += resultNoData[0];
        } else {
          this.indexNoDataText += "and " + resultNoData[0];
        }
      }

      result = result.filter((x) => x.data[0] != 0 || x.data[0] != 0);

      result.sort((a, b) => b.dif - a.dif);

      this.indexChart.series[0].data = [];
      this.indexChart.series[1].data = [];
      this.indexChart.series[0].name = this.firstHalfPeriod;
      this.indexChart.series[1].name = this.secondHalfPeriod;

      for (let k = 0; k < result.length; k++) {
        this.indexChart.series[0].data[k] = result[k].data[0];
        this.indexChart.series[1].data[k] = result[k].data[1];
        this.indexChart.catName[k] = result[k].catName;
      }
    },
    async loadIndexChart() {
      let _this = this;
      Highcharts.chart("chartIndex", {
        chart: {
          type: "bar",
          backgroundColor: "#EDEDED",
          marginLeft: 380,
          marginBottom: 20,
          height: 400,
          events: {
            load: function () {
              var axis = this.xAxis[0];
              var ticks = axis.ticks;
              var points = this.series[0].points;
              points.forEach(function (point, i) {
                if (ticks[i]) {
                  var label = ticks[i].label.element;
                  label.onclick = function (ev) {
                    _this.indicatorName = ev.target.innerHTML.replace(
                      /<[^>]*>?/gm,
                      ""
                    );

                    // _this.indicatorIndex = ev.point.index;
                    _this.setIndicatorChart();
                  };
                }
              });
            },
          },
        },

        title: {
          text: "",
        },
        xAxis: {
          categories: this.indexChart.catName,

          labels: {
            // align: "left",
            // x: -220,
            align: "center",
            style: {
              cursor: "pointer",
            },
            formatter() {
              if (this.value == _this.yourGroupName)
                return `<span style="color: #F99704; font-weight:bold;">${this.value}</span>`;
              else {
                return this.value;
              }
            },
          },
        },
        yAxis: {
          min: 0,
          max: 1,
          title: {
            text: "",
          },
          gridLineWidth: 0,
          minorGridLineWidth: 0,
        },
        tooltip: {
          shared: true,
          formatter: function () {
            let points = this.points;
            let pointsLength = points.length;
            let tooltipMarkup = pointsLength
              ? '<span style="font-size: 14px"><b>' +
                points[0].key +
                "</b></span><br/>"
              : "";
            let difData = Number(
              (this.points[1].y - this.points[0].y).toFixed(2)
            );
            let percentDif;
            if (this.points[0].y != 0) {
              percentDif = Number(
                ((this.points[1].y - this.points[0].y) / this.points[0].y) * 100
              ).toFixed(2);
            } else {
              percentDif = "0.00";
            }
            let textDif = difData < 0 ? "decreased" : "increased";
            tooltipMarkup +=
              "Average index " +
              textDif +
              " by " +
              Math.abs(difData).toFixed(2) +
              " ( " +
              Math.abs(percentDif).toFixed(2) +
              "% )";

            return tooltipMarkup;
          },
        },
        plotOptions: {
          bar: {
            pointPadding: 0,
            borderWidth: 0,
            dataLabels: {
              align: "right",
              enabled: true,
              borderWidth: 0,
              inside: true,
              formatter: function () {
                return Highcharts.numberFormat(this.y, 2);
              },
              // format: "{y} %",
            },
          },
          series: {
            pointPadding: 0,
            borderWidth: 0,
            events: {
              click: function (ev) {
                if (ev.point.category !== _this.yourGroupName) {
                  _this.indicatorName = ev.point.category;
                  _this.setIndicatorChart();
                }
              },
              legendItemClick: function (e) {
                e.preventDefault();
              },
            },
            cursor: "pointer",
          },
        },
        legend: {
          align: "right",
          verticalAlign: "top",
          y: 50,
          layout: "vertical",
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: [
                "viewFullscreen",
                "printChart",
                "separator",
                "downloadPNG",
                "downloadJPEG",
                "downloadPDF",
                "downloadSVG",
                "separator",
                "downloadCSV",
                "downloadXLS",
                //"viewData",
              ],
            },
          },
        },
        // legend: { enabled: false },
        credits: { enabled: false },
        series: this.indexChart.series,
      });
    },
    async setDataChart() {
      let dataTemp = {
        input: this.input,
        partnerMap: this.data.map((x) => x.iso),
        reportMap: this.report.map((x) => x.iso),
        dimension: this.dimensionIndex,
      };
      let url = this.ri_api + "economy/data_dimensiontab.php";
      let res = await axios.post(url, JSON.stringify(dataTemp));
      let result = res.data;
      let tableTemp = [];
      let totalIndex = this.indicatorStr.length;
      this.weightDataTemp = [];
      for (let i = 1; i <= totalIndex; i++) {
        let indexCount =
          (result.filter((x) => Number(x.indicator) == i).length /
            this.countAllPair) *
          100;

        let tPush = {
          data: indexCount,
          catName: this.indicatorStr[i - 1],
        };
        tableTemp.push(tPush);

        let weightCount =
          result.filter((x) => Number(x.indicator) == i).length / result.length;
        let wPush = {
          data: weightCount,
          catName: this.indicatorStr[i - 1],
        };
        this.weightDataTemp.push(wPush);
      }

      tableTemp.sort((a, b) => b.data - a.data);

      this.dataChart.catName = tableTemp.map((x) => x.catName);
      this.dataChart.catNameLower = tableTemp.map((x) => {
        return x.catName.charAt(0).toLowerCase() + x.catName.substring(1);
      });
      this.dataChart.series[0].data = tableTemp.map((x) => x.data);
      let checkAvailable = this.dataChart.series[0].data.filter((x) => x > 0);
      if (checkAvailable.length == 0) {
        this.showAvail = false;
      } else {
        this.showAvail = true;
      }
    },
    async loadDataChart() {
      Highcharts.chart("chartData", {
        chart: {
          type: "bar",
          backgroundColor: "#EDEDED",
          marginLeft: 230,
          marginRight: 50,
        },

        title: {
          text: "",
        },
        xAxis: {
          categories: this.dataChart.catName,
          labels: {
            // align: "left",
            // x: -220,
            align: "center",
          },
        },
        yAxis: {
          min: 0,
          max: 100,
          title: {
            text: "",
          },
          labels: {
            format: "{value} %",
          },
          gridLineWidth: 0,
        },
        tooltip: {
          valueSuffix: " %",
          valueDecimals: 2,
        },
        plotOptions: {
          bar: {
            dataLabels: {
              align: "right",
              enabled: true,
              borderWidth: 0,
              inside: true,
              formatter: function () {
                return Highcharts.numberFormat(this.y, 2) + "%";
              },
            },
          },
          series: {
            pointWidth: 50,
            pointPadding: 0,
            borderWidth: 0,
          },
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: [
                "viewFullscreen",
                "printChart",
                "separator",
                "downloadPNG",
                "downloadJPEG",
                "downloadPDF",
                "downloadSVG",
                "separator",
                "downloadCSV",
                "downloadXLS",
                //"viewData",
              ],
            },
          },
        },
        legend: { enabled: false },
        credits: { enabled: false },
        series: this.dataChart.series,
      });
    },
    async setWeightChart() {
      this.weightDataTemp.sort((a, b) => b.data - a.data);

      this.weightChart.series[0].data = [];
      this.weightChart.catName = this.weightDataTemp.map((x) => x.catName);
      this.weightChart.catNameLower = this.weightDataTemp.map((x) => {
        return x.catName.charAt(0).toLowerCase() + x.catName.substring(1);
      });
      this.weightChart.series[0].data = this.weightDataTemp.map(
        (x) => Number(x.data) * 100
      );

      this.weightChart.equalWeight = (
        100 / this.weightChart.series[0].data.length
      ).toFixed(2);
    },
    async loadWeightChart() {
      Highcharts.chart("chartWeight", {
        chart: {
          type: "bar",
          backgroundColor: "#EDEDED",
          marginLeft: 230,
          marginRight: 50,
        },

        title: {
          text: "",
        },
        xAxis: {
          categories: this.weightChart.catName,
          labels: {
            // align: "left",
            // x: -220,
            align: "center",
          },
        },
        yAxis: {
          min: 0,
          max: 100,
          title: {
            text: "",
          },
          gridLineWidth: 0,
          plotLines: [
            {
              color: "#FF0000",
              dashStyle: "dash",
              zIndex: 5,
              width: 2,
              value: this.weightChart.equalWeight,
              label: {
                text: "Equal weighting: " + this.weightChart.equalWeight,
                rotation: 360,
              },
            },
          ],
        },
        tooltip: {
          valueDecimals: 2,
        },
        plotOptions: {
          bar: {
            dataLabels: {
              align: "right",
              enabled: true,
              borderWidth: 0,
              inside: true,
              formatter: function () {
                return Highcharts.numberFormat(this.y, 2);
              },
            },
          },
          series: {
            pointWidth: 50,
            pointPadding: 0,
            borderWidth: 0,
          },
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: [
                "viewFullscreen",
                "printChart",
                "separator",
                "downloadPNG",
                "downloadJPEG",
                "downloadPDF",
                "downloadSVG",
                "separator",
                "downloadCSV",
                "downloadXLS",
                //"viewData",
              ],
            },
          },
        },
        legend: { enabled: false },
        credits: { enabled: false },
        series: this.weightChart.series,
      });
    },
    async setIndicatorChart() {
      let yearMin = this.input.year.min;
      let yearMax = this.input.year.max;

      let diffYear = Math.floor(
        (this.input.year.max - this.input.year.min) / 2
      );
      let indexI = 0;
      for (let i = 0; i < this.indicatorStr.length; i++) {
        if (this.indicatorName == this.indicatorStr[i]) {
          indexI = i + 1;
        }
      }
      let sendData = {
        input: this.input,
        partnerMap: this.data.map((x) => x.iso),
        reportMap: this.report.map((x) => x.iso),
        dimension: this.dimensionIndex,
        index: indexI,
      };

      let url = this.ri_api + "economy/indicatorchart_datatab_dimension.php";
      let res = await axios.post(url, JSON.stringify(sendData));
      let tempTable = res.data;
      let result = [];
      this.indicatorChart.series[0].name = this.firstHalfPeriod;
      this.indicatorChart.series[1].name = this.secondHalfPeriod;

      for (let j = 0; j < sendData.partnerMap.length; j++) {
        let eachCountry = tempTable.filter(
          (country) =>
            country.reporter == sendData.partnerMap[j] ||
            country.partner == sendData.partnerMap[j]
        );

        if (eachCountry.length != 0) {
          let firstHalf = eachCountry.filter(
            (x) => x.year <= yearMin + diffYear
          );
          let secondHalf = eachCountry.filter(
            (x) => x.year >= yearMax - diffYear
          );
          let firstScore =
            firstHalf.reduce((a, b) => a + Number(b.score), 0) /
            firstHalf.length;
          let secondScore =
            secondHalf.reduce((a, b) => a + Number(b.score), 0) /
            secondHalf.length;
          let tempPush = {
            country: this.data[j].label,
            data: [],
            dif: Number(secondScore - firstScore),
          };
          tempPush.data[0] = Number(firstScore);
          tempPush.data[1] = Number(secondScore);
          result.push(tempPush);
        }
      }
      result.sort((a, b) => b.dif - a.dif);
      for (let k in result) {
        this.indicatorChart.series[0].data[k] = result[k].data[0];
        this.indicatorChart.series[1].data[k] = result[k].data[1];
        this.indicatorChart.catName[k] = result[k].country;
      }
      this.loadIndicatorChart();
      this.showIndicatorChart = true;
    },
    async loadIndicatorChart() {
      Highcharts.chart("chartIndicator", {
        chart: {
          type: "bar",
          backgroundColor: "#EDEDED",
          marginLeft: 160,
          height:
            this.indicatorChart.catName.length > 9
              ? this.indicatorChart.catName.length * 60
              : 580,
        },

        title: {
          text: "",
        },
        xAxis: {
          categories: this.indicatorChart.catName,
          labels: {
            align: "right",
          },
        },
        yAxis: {
          min: 0,
          max: 1,
          title: {
            text: "",
          },
          gridLineWidth: 0,
          minorGridLineWidth: 0,
        },
        tooltip: {
          shared: true,
          formatter: function () {
            let points = this.points;
            let pointsLength = points.length;
            let tooltipMarkup = pointsLength
              ? '<span style="font-size: 14px"><b>' +
                points[0].key +
                "</b></span><br/>"
              : "";
            let difData = Number(
              (this.points[1].y - this.points[0].y).toFixed(2)
            );
            let percentDif = Number(
              ((this.points[1].y - this.points[0].y) / this.points[0].y) * 100
            ).toFixed(2);
            let textDif = difData < 0 ? "decreased" : "increased";
            tooltipMarkup +=
              "Average index " +
              textDif +
              " by " +
              Math.abs(difData).toFixed(2) +
              " ( " +
              Math.abs(percentDif).toFixed(2) +
              "% )";

            return tooltipMarkup;
          },
        },
        plotOptions: {
          bar: {
            pointPadding: 0,
            borderWidth: 0,
            dataLabels: {
              align: "right",
              enabled: true,
              borderWidth: 0,
              inside: true,
              formatter: function () {
                return Highcharts.numberFormat(this.y, 2);
              },
            },
          },
          series: {
            pointPadding: 0,
            borderWidth: 0,
            events: {
              legendItemClick: function (e) {
                e.preventDefault();
              },
            },
          },
        },
        legend: {
          align: "right",
          verticalAlign: "top",
          y: 50,
          layout: "vertical",
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: [
                "viewFullscreen",
                "printChart",
                "separator",
                "downloadPNG",
                "downloadJPEG",
                "downloadPDF",
                "downloadSVG",
                "separator",
                "downloadCSV",
                "downloadXLS",
                //"viewData",
              ],
            },
          },
        },
        credits: { enabled: false },
        series: this.indicatorChart.series,
      });
    },
    async setEconomyChart() {
      //
      let dataTemp = {
        input: this.input,
        partner: this.data,
        partnerMap: this.data.map((x) => x.iso),
        reportMap: this.report.map((x) => x.iso),
        dimension: this.selected,
        index: this.dimensionIndex,
      };
      let url = this.ri_api + "economy/economychart_datatab_dimension.php";
      let res = await axios.post(url, JSON.stringify(dataTemp));
      let result = res.data;
      result.sort((a, b) => b.dif - a.dif);

      this.economyChart.series[0].data = [];
      this.economyChart.series[1].data = [];
      // @ Youy group
      this.economyChart.series[0].name = this.firstHalfPeriod;
      this.economyChart.series[1].name = this.secondHalfPeriod;

      for (let k = 0; k < result.length; k++) {
        this.economyChart.series[0].data[k] = Number(
          Number(result[k].data[0]).toFixed(4)
        );
        this.economyChart.series[1].data[k] = Number(
          Number(result[k].data[1]).toFixed(4)
        );
        this.economyChart.catName[k] = result[k].country;
      }
    },
    async loadEconomyChart() {
      let _this = this;
      Highcharts.chart("z", {
        chart: {
          type: "bar",
          backgroundColor: "#EDEDED",
          marginLeft: 180,
          height: this.data.length > 9 ? this.data.length * 60 : 540,
        },

        title: {
          text: "",
        },
        xAxis: {
          categories: this.economyChart.catName,
          labels: {
            align: "right",

            formatter() {
              if (this.value == _this.yourGroupName)
                return `<span style="color: #F99704; font-weight:bold;">${this.value}</span>`;
              else {
                return this.value;
              }
            },
          },
        },
        yAxis: {
          min: 0,
          max: 1,
          title: {
            text: "",
          },
          gridLineWidth: 0,
          minorGridLineWidth: 0,
        },
        tooltip: {
          shared: true,
          formatter: function () {
            let points = this.points;
            let pointsLength = points.length;
            let tooltipMarkup = pointsLength
              ? '<span style="font-size: 14px"><b>' +
                points[0].key +
                "</b></span><br/>"
              : "";

            let difData = Number(
              (this.points[1].y - this.points[0].y).toFixed(2)
            );
            let percentDif;
            if (this.points[0].y != 0) {
              percentDif = Number(
                ((this.points[1].y - this.points[0].y) / this.points[0].y) * 100
              ).toFixed(2);
            } else {
              percentDif = "0.00";
            }
            let textDif = difData < 0 ? "decreased" : "increased";
            tooltipMarkup +=
              "Average index " +
              textDif +
              " by " +
              Math.abs(difData).toFixed(2) +
              " ( " +
              Math.abs(percentDif).toFixed(2) +
              "% )";

            return tooltipMarkup;
          },
        },
        plotOptions: {
          bar: {
            pointPadding: 0,
            borderWidth: 0,
            dataLabels: {
              align: "right",
              enabled: true,
              borderWidth: 0,
              inside: true,
              // format: "{y} %",
              formatter: function () {
                return Highcharts.numberFormat(this.y, 2);
              },
            },
          },
          series: {
            pointPadding: 0,
            borderWidth: 0,
            events: {
              legendItemClick: function (e) {
                e.preventDefault();
              },
            },
          },
        },
        legend: {
          align: "right",
          y: 50,
          verticalAlign: "top",
          layout: "vertical",
        },
        exporting: {
          buttons: {
            contextButton: {
              menuItems: [
                "viewFullscreen",
                "printChart",
                "separator",
                "downloadPNG",
                "downloadJPEG",
                "downloadPDF",
                "downloadSVG",
                "separator",
                "downloadCSV",
                "downloadXLS",
                //"viewData",
              ],
            },
          },
        },
        credits: { enabled: false },
        series: this.economyChart.series,
      });
    },
    async checkYourName() {
      this.yourGroupName = this.input.reporting.label;
      await this.loadData();
    },
  },
  mounted() {
    this.checkYourName();
  },
};
</script>

<style lang="scss" scoped>
.economyOverflow2 {
  width: 100%;
  height: 520px;
  overflow-y: auto;
}
.bgGrey {
  background: #ededed;
  height: 980px;
}
.textGrey {
  color: #757575;
}
.inputSelectClass {
  background: #2d9687;
  padding-left: 14px;
  width: 400px;
  color: white;
  height: 40px;
  line-height: 40px;
  font-size: 24px;
}
.cardStyle {
  background: #ededed;
  border: 1px solid #757575;
  height: 750px;
}
////////////
.cardIndicator {
  max-width: 1200px;
  max-height: 800px;
  width: 1200px;
  height: 750px;
  background: #f7f7f7;
  z-index: 999999;
}
.chartincard {
  width: 100%;
  height: 580px;
  background: #c4c4c4;
  overflow-y: auto;
}
.bgDrop {
  background-color: rgba($color: #000000, $alpha: 0.6);
}
.economyOverflow {
  width: 100%;
  height: 540px;
  overflow-y: auto;
}
/////
#chartIndicator {
  min-height: 580px;
  width: 100%;
}
#chartEconomy {
  min-height: 540px;
  width: 100%;
}
#chartIndex {
  height: 420px;
  width: 100%;
}
#chartData,
#chartWeight {
  height: 510px;
  width: 100%;
}
.noDataAvail {
  font-size: 32px;
  padding-top: 250px;
}
</style>
